]> git.ipfire.org Git - thirdparty/dracut.git/blame - dracut.sh
dracut.sh: Adjust squash and strip order
[thirdparty/dracut.git] / dracut.sh
CommitLineData
c1c78f8a 1#!/bin/bash -p
3b403b32 2#
641cc356
JK
3# Generator script for a dracut initramfs
4# Tries to retain some degree of compatibility with the command line
5# of the various mkinitrd implementations out there
6#
70c26b7f 7
7d848c55 8# Copyright 2005-2013 Red Hat, Inc. All rights reserved.
4f18fe82
HH
9#
10# This program is free software; you can redistribute it and/or modify
11# it under the terms of the GNU General Public License as published by
12# the Free Software Foundation; either version 2 of the License, or
13# (at your option) any later version.
14#
15# This program is distributed in the hope that it will be useful,
16# but WITHOUT ANY WARRANTY; without even the implied warranty of
17# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
18# GNU General Public License for more details.
19#
20# You should have received a copy of the GNU General Public License
21# along with this program. If not, see <http://www.gnu.org/licenses/>.
22#
ec9315e5 23
58dad702 24# store for logging
ee44f629 25
c1c78f8a
RM
26unset BASH_ENV
27
ee44f629
HH
28# Verify bash version, current minimum is 4
29if (( BASH_VERSINFO[0] < 4 )); then
30 printf -- 'You need at least Bash 4 to use dracut, sorry.' >&2
31 exit 1
32fi
33
ffa71b4a 34dracut_args=( "$@" )
e8f19bcf 35readonly dracut_cmd="$(readlink -f $0)"
5616feb0 36
7abd4264
HH
37set -o pipefail
38
5616feb0 39usage() {
dbf8f6ba
HH
40 [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
41 if [[ -f $dracutbasedir/dracut-version.sh ]]; then
42 . $dracutbasedir/dracut-version.sh
43 fi
44
5616feb0 45# 80x25 linebreak here ^
cc02093d 46 cat << EOF
e8f19bcf 47Usage: $dracut_cmd [OPTION]... [<initramfs> [<kernel-version>]]
ffa71b4a
HH
48
49Version: $DRACUT_VERSION
50
51Creates initial ramdisk images for preloading modules
52
53 -h, --help Display all options
54
55If a [LIST] has multiple arguments, then you have to put these in quotes.
56
57For example:
58
59 # dracut --add-drivers "module1 module2" ...
60
61EOF
62}
63
64long_usage() {
65 [[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
66 if [[ -f $dracutbasedir/dracut-version.sh ]]; then
67 . $dracutbasedir/dracut-version.sh
68 fi
69
70# 80x25 linebreak here ^
71 cat << EOF
e8f19bcf 72Usage: $dracut_cmd [OPTION]... [<initramfs> [<kernel-version>]]
dbf8f6ba
HH
73
74Version: $DRACUT_VERSION
75
5616feb0
AT
76Creates initial ramdisk images for preloading modules
77
e65caf36 78 --kver [VERSION] Set kernel version to [VERSION].
39ff0682 79 -f, --force Overwrite existing initramfs file.
54e7d7c3 80 -a, --add [LIST] Add a space-separated list of dracut modules.
659dc319 81 --rebuild Append arguments to those of existing image and rebuild
5616feb0
AT
82 -m, --modules [LIST] Specify a space-separated list of dracut modules to
83 call when building the initramfs. Modules are located
c5a65990 84 in /usr/lib/dracut/modules.d.
39ff0682 85 -o, --omit [LIST] Omit a space-separated list of dracut modules.
ea3c4e82
HH
86 --force-add [LIST] Force to add a space-separated list of dracut modules
87 to the default set of modules, when -H is specified.
5616feb0 88 -d, --drivers [LIST] Specify a space-separated list of kernel modules to
ea3c4e82
HH
89 exclusively include in the initramfs.
90 --add-drivers [LIST] Specify a space-separated list of kernel
91 modules to add to the initramfs.
cea907f6
TR
92 --force-drivers [LIST] Specify a space-separated list of kernel
93 modules to add to the initramfs and make sure they
94 are tried to be loaded via modprobe same as passing
95 rd.driver.pre=DRIVER kernel parameter.
fcbcb252 96 --omit-drivers [LIST] Specify a space-separated list of kernel
ea3c4e82 97 modules not to add to the initramfs.
8fa510d4 98 --filesystems [LIST] Specify a space-separated list of kernel filesystem
ea3c4e82
HH
99 modules to exclusively include in the generic
100 initramfs.
3b403b32 101 -k, --kmoddir [DIR] Specify the directory, where to look for kernel
ea3c4e82 102 modules
3b403b32 103 --fwdir [DIR] Specify additional directories, where to look for
ea3c4e82 104 firmwares, separated by :
33ee031c
HH
105 --kernel-only Only install kernel drivers and firmware files
106 --no-kernel Do not install kernel drivers and firmware files
1743473b 107 --print-cmdline Print the kernel command line for the given disk layout
5bbfd484 108 --early-microcode Combine early microcode with ramdisk
5f2c30d9 109 --no-early-microcode Do not combine early microcode with ramdisk
d20fb951 110 --kernel-cmdline [PARAMETERS] Specify default kernel command line parameters
54e7d7c3 111 --strip Strip binaries in the initramfs
6c128565 112 --nostrip Do not strip binaries in the initramfs
54e7d7c3 113 --hardlink Hardlink files in the initramfs
04d18f55 114 --nohardlink Do not hardlink files in the initramfs
fd786adc 115 --prefix [DIR] Prefix initramfs files with [DIR]
54e7d7c3 116 --noprefix Do not prefix initramfs files
2f02ae9d
HH
117 --mdadmconf Include local /etc/mdadm.conf
118 --nomdadmconf Do not include local /etc/mdadm.conf
7a34efa5 119 --lvmconf Include local /etc/lvm/lvm.conf
cc02093d 120 --nolvmconf Do not include local /etc/lvm/lvm.conf
25b45979
MS
121 --fscks [LIST] Add a space-separated list of fsck helpers.
122 --nofscks Inhibit installation of any fsck helpers.
ff3953ef 123 --ro-mnt Mount / and /usr read-only by default.
5616feb0 124 -h, --help This message
00531568 125 --debug Output debug information of the build process
57258a2c 126 --profile Output profile information of the build process
e103615b
127 -L, --stdlog [0-6] Specify logging level (to standard error)
128 0 - suppress any messages
129 1 - only fatal errors
130 2 - all errors
131 3 - warnings
54e7d7c3 132 4 - info
e103615b
133 5 - debug info (here starts lots of output)
134 6 - trace info (and even more)
54e7d7c3
HH
135 -v, --verbose Increase verbosity level
136 -q, --quiet Decrease verbosity level
5616feb0
AT
137 -c, --conf [FILE] Specify configuration file to use.
138 Default: /etc/dracut.conf
3b403b32 139 --confdir [DIR] Specify configuration directory to use *.conf files
cc02093d 140 from. Default: /etc/dracut.conf.d
882c4c5a
141 --tmpdir [DIR] Temporary directory to be used instead of default
142 /var/tmp.
5616feb0
AT
143 -l, --local Local mode. Use modules from the current working
144 directory instead of the system-wide installed in
c5a65990 145 /usr/lib/dracut/modules.d.
5616feb0 146 Useful when running dracut from a git checkout.
7c179686 147 -H, --hostonly Host-Only mode: Install only what is needed for
324ea606 148 booting the local host instead of a generic host.
472189da 149 -N, --no-hostonly Disables Host-Only mode
a695250e
KS
150 --hostonly-mode <mode>
151 Specify the hostonly mode to use. <mode> could be
152 one of "sloppy" or "strict". "sloppy" mode is used
153 by default.
154 In "sloppy" hostonly mode, extra drivers and modules
155 will be installed, so minor hardware change won't make
156 the image unbootable (eg. changed keyboard), and the
157 image is still portable among similar hosts.
158 With "strict" mode enabled, anything not necessary
159 for booting the local host in its current state will
160 not be included, and modules may do some extra job
161 to save more space. Minor change of hardware or
162 environment could make the image unbootable.
163 DO NOT use "strict" mode unless you know what you
164 are doing.
ab9457ef
HH
165 --hostonly-cmdline Store kernel command line arguments needed
166 in the initramfs
167 --no-hostonly-cmdline Do not store kernel command line arguments needed
168 in the initramfs
37f2fe55
XP
169 --no-hostonly-default-device
170 Do not generate implicit host devices like root,
171 swap, fstab, etc. Use "--mount" or "--add-device"
172 to explicitly add devices as needed.
f367b738
HH
173 --hostonly-i18n Install only needed keyboard and font files according
174 to the host configuration (default).
175 --no-hostonly-i18n Install all keyboard and font files available.
324ea606
HH
176 --persistent-policy [POLICY]
177 Use [POLICY] to address disks and partitions.
178 POLICY can be any directory name found in /dev/disk.
179 E.g. "by-uuid", "by-label"
7c179686 180 --fstab Use /etc/fstab to determine the root device.
70cb8a68
HH
181 --add-fstab [FILE] Add file to the initramfs fstab
182 --mount "[DEV] [MP] [FSTYPE] [FSOPTS]"
183 Mount device [DEV] on mountpoint [MP] with filesystem
184 [FSTYPE] and options [FSOPTS] in the initramfs
edbd9ca0
FV
185 --mount "[MP]" Same as above, but [DEV], [FSTYPE] and [FSOPTS] are
186 determined by looking at the current mounts.
c586b033 187 --add-device "[DEV]" Bring up [DEV] in initramfs
5616feb0 188 -i, --include [SOURCE] [TARGET]
39ff0682
AT
189 Include the files in the SOURCE directory into the
190 Target directory in the final initramfs.
3b403b32 191 If SOURCE is a file, it will be installed to TARGET
4fea3ea6 192 in the final initramfs.
39ff0682
AT
193 -I, --install [LIST] Install the space separated list of files into the
194 initramfs.
54b68829
HH
195 --install-optional [LIST] Install the space separated list of files into the
196 initramfs, if they exist.
5b158ad3 197 --gzip Compress the generated initramfs using gzip.
cc02093d
HH
198 This will be done by default, unless another
199 compression option or --no-compress is passed.
5b158ad3 200 --bzip2 Compress the generated initramfs using bzip2.
cc02093d
HH
201 Make sure your kernel has bzip2 decompression support
202 compiled in, otherwise you will not be able to boot.
203 --lzma Compress the generated initramfs using lzma.
3b403b32 204 Make sure your kernel has lzma support compiled in,
cc02093d 205 otherwise you will not be able to boot.
5e6c3b03
VL
206 --xz Compress the generated initramfs using xz.
207 Make sure that your kernel has xz support compiled
208 in, otherwise you will not be able to boot.
37383f71 209 --lzo Compress the generated initramfs using lzop.
871c8e40 210 Make sure that your kernel has lzo support compiled
211 in, otherwise you will not be able to boot.
37383f71 212 --lz4 Compress the generated initramfs using lz4.
871c8e40 213 Make sure that your kernel has lz4 support compiled
214 in, otherwise you will not be able to boot.
7dbadcc7
TPG
215 --zstd Compress the generated initramfs using Zstandard.
216 Make sure that your kernel has zstd support compiled
217 in, otherwise you will not be able to boot.
5e6c3b03
VL
218 --compress [COMPRESSION] Compress the generated initramfs with the
219 passed compression program. Make sure your kernel
3b403b32 220 knows how to decompress the generated initramfs,
5e6c3b03 221 otherwise you will not be able to boot.
5b158ad3 222 --no-compress Do not compress the generated initramfs. This will
cc02093d 223 override any other compression options.
5b11bb73 224 --list-modules List all available dracut modules.
956af8f2
225 -M, --show-modules Print included module's name to standard output during
226 build.
5fe5c7d0 227 --keep Keep the temporary initramfs for debugging purposes
ec3c5951 228 --printsize Print out the module install size
cdfeb278 229 --sshkey [SSHKEY] Add ssh key to initramfs (use with ssh-client module)
ee54b840 230 --logfile [FILE] Logfile to use (overrides configuration setting)
80626ded 231 --reproducible Create reproducible images
10f8df1b 232 --no-reproducible Do not create reproducible images
37383f71 233 --loginstall [DIR] Log all files installed from the host to [DIR]
636d2d46
HH
234 --uefi Create an UEFI executable with the kernel cmdline and
235 kernel combined
236 --uefi-stub [FILE] Use the UEFI stub [FILE] to create an UEFI executable
237 --kernel-image [FILE] location of the kernel image
ccaa9bee
HH
238
239If [LIST] has multiple arguments, then you have to put these in quotes.
ffa71b4a 240
ccaa9bee 241For example:
ffa71b4a
HH
242
243 # dracut --add-drivers "module1 module2" ...
244
cc02093d 245EOF
5616feb0
AT
246}
247
118ca9ec
TR
248# Fills up host_devs stack variable and makes sure there are no duplicates
249push_host_devs() {
250 local _dev
694725ab
HH
251 for _dev in "$@"; do
252 [[ " ${host_devs[@]} " == *" $_dev "* ]] && return
253 host_devs+=( "$_dev" )
254 done
8466db96
HH
255}
256
5bc545ed
VL
257# Little helper function for reading args from the commandline.
258# it automatically handles -a b and -a=b variants, and returns 1 if
259# we need to shift $3.
260read_arg() {
261 # $1 = arg name
262 # $2 = arg value
263 # $3 = arg parameter
264 local rematch='^[^=]*=(.*)$'
265 if [[ $2 =~ $rematch ]]; then
cc02093d 266 read "$1" <<< "${BASH_REMATCH[1]}"
5bc545ed 267 else
cc02093d
HH
268 read "$1" <<< "$3"
269 # There is no way to shift our callers args, so
270 # return 1 to indicate they should do it instead.
271 return 1
5bc545ed
VL
272 fi
273}
274
335bc217 275dropindirs_sort()
a42b2b81 276{
b093aa2d
HH
277 local suffix=$1; shift
278 local -a files
279 local f d
280
dba20559
HH
281 for d in "$@"; do
282 for i in "$d/"*"$suffix"; do
283 if [[ -e "$i" ]]; then
284 printf "%s\n" "${i##*/}"
285 fi
286 done
287 done | sort -Vu | {
288 readarray -t files
289
290 for f in "${files[@]}"; do
291 for d in "$@"; do
292 if [[ -e "$d/$f" ]]; then
293 printf "%s\n" "$d/$f"
294 continue 2
b093aa2d 295 fi
a42b2b81 296 done
a42b2b81 297 done
dba20559 298 }
a42b2b81
HH
299}
300
659dc319
HB
301rearrange_params()
302{
303 # Workaround -i, --include taking 2 arguments
dcacd2b0
FV
304 newat=()
305 for i in "$@"; do
306 if [[ $i == "-i" ]] || [[ $i == "--include" ]]; then
307 newat+=("++include") # Replace --include by ++include
308 else
309 newat+=("$i")
310 fi
311 done
312 set -- "${newat[@]}" # Set new $@
659dc319
HB
313
314 TEMP=$(unset POSIXLY_CORRECT; getopt \
315 -o "a:m:o:d:I:k:c:L:fvqlHhMN" \
316 --long kver: \
317 --long add: \
318 --long force-add: \
319 --long add-drivers: \
cea907f6 320 --long force-drivers: \
659dc319
HB
321 --long omit-drivers: \
322 --long modules: \
323 --long omit: \
324 --long drivers: \
325 --long filesystems: \
326 --long install: \
54b68829 327 --long install-optional: \
659dc319
HB
328 --long fwdir: \
329 --long libdirs: \
330 --long fscks: \
331 --long add-fstab: \
332 --long mount: \
333 --long device: \
334 --long add-device: \
ae989390 335 --long nofscks \
659dc319
HB
336 --long ro-mnt \
337 --long kmoddir: \
338 --long conf: \
339 --long confdir: \
340 --long tmpdir: \
341 --long stdlog: \
342 --long compress: \
343 --long prefix: \
344 --long rebuild: \
345 --long force \
346 --long kernel-only \
347 --long no-kernel \
348 --long print-cmdline \
349 --long kernel-cmdline: \
350 --long strip \
351 --long nostrip \
659dc319
HB
352 --long hardlink \
353 --long nohardlink \
354 --long noprefix \
355 --long mdadmconf \
356 --long nomdadmconf \
357 --long lvmconf \
358 --long nolvmconf \
359 --long debug \
360 --long profile \
361 --long sshkey: \
362 --long logfile: \
363 --long verbose \
364 --long quiet \
365 --long local \
366 --long hostonly \
367 --long host-only \
368 --long no-hostonly \
369 --long no-host-only \
a695250e 370 --long hostonly-mode: \
646e0506
WC
371 --long hostonly-cmdline \
372 --long no-hostonly-cmdline \
37f2fe55 373 --long no-hostonly-default-device \
659dc319
HB
374 --long persistent-policy: \
375 --long fstab \
376 --long help \
377 --long bzip2 \
378 --long lzma \
379 --long xz \
380 --long lzo \
381 --long lz4 \
7dbadcc7 382 --long zstd \
659dc319
HB
383 --long no-compress \
384 --long gzip \
385 --long list-modules \
386 --long show-modules \
387 --long keep \
388 --long printsize \
389 --long regenerate-all \
390 --long noimageifnotneeded \
391 --long early-microcode \
392 --long no-early-microcode \
80626ded 393 --long reproducible \
10f8df1b 394 --long no-reproducible \
37383f71 395 --long loginstall: \
636d2d46
HH
396 --long uefi \
397 --long uefi-stub: \
398 --long kernel-image: \
b73e00af
HH
399 --long no-hostonly-i18n \
400 --long hostonly-i18n \
5c57209b 401 --long no-machineid \
659dc319
HB
402 -- "$@")
403
404 if (( $? != 0 )); then
405 usage
406 exit 1
407 fi
408}
409
432196ae 410verbosity_mod_l=0
f79e587c
HH
411unset kernel
412unset outfile
486a1b93 413
659dc319
HB
414rearrange_params "$@"
415eval set -- "$TEMP"
416
417# parse command line args to check if '--rebuild' option is present
418unset append_args_l
419unset rebuild_file
420while :
421do
422 if [ "$1" == "--" ]; then
423 shift; break
424 fi
425 if [ "$1" == "--rebuild" ]; then
426 append_args_l="yes"
427 rebuild_file=$2
428 if [ ! -e $rebuild_file ]; then
429 echo "Image file '$rebuild_file', for rebuild, does not exist!"
430 exit 1
431 fi
432 abs_rebuild_file=$(readlink -f "$rebuild_file") && rebuild_file="$abs_rebuild_file"
433 shift; continue
434 fi
435 shift
436done
437
438# get output file name and kernel version from command line arguments
439while (($# > 0)); do
440 case ${1%%=*} in
441 ++include)
442 shift 2;;
443 *)
444 if ! [[ ${outfile+x} ]]; then
445 outfile=$1
446 elif ! [[ ${kernel+x} ]]; then
447 kernel=$1
448 else
449 printf "\nUnknown arguments: %s\n\n" "$*" >&2
450 usage; exit 1;
451 fi
452 ;;
453 esac
454 shift
455done
456
457# extract input image file provided with rebuild option to get previous parameters, if any
458if [[ $append_args_l == "yes" ]]; then
459 unset rebuild_param
460
461 # determine resultant file
462 if ! [[ $outfile ]]; then
463 outfile=$rebuild_file
464 fi
465
466 if ! rebuild_param=$(lsinitrd $rebuild_file '*lib/dracut/build-parameter.txt'); then
467 echo "Image '$rebuild_file' has no rebuild information stored"
468 exit 1
469 fi
470
471 # prepend previous parameters to current command line args
472 if [[ $rebuild_param ]]; then
473 TEMP="$rebuild_param $TEMP"
474 eval set -- "$TEMP"
475 rearrange_params "$@"
476 fi
ffa71b4a
HH
477fi
478
659dc319
HB
479unset PARMS_TO_STORE
480PARMS_TO_STORE=""
481
ffa71b4a
HH
482eval set -- "$TEMP"
483
484while :; do
659dc319
HB
485 if [ $1 != "--" ] && [ $1 != "--rebuild" ]; then
486 PARMS_TO_STORE+=" $1";
487 fi
ffa71b4a 488 case $1 in
5a66d511
HH
489 --kver) kernel="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
490 -a|--add) add_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
491 --force-add) force_add_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
492 --add-drivers) add_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
493 --force-drivers) force_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
494 --omit-drivers) omit_drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
495 -m|--modules) dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
496 -o|--omit) omit_dracutmodules_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
497 -d|--drivers) drivers_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
498 --filesystems) filesystems_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
499 -I|--install) install_items_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
500 --install-optional) install_optional_items_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
501 --fwdir) fw_dir_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
502 --libdirs) libdirs_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
503 --fscks) fscks_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
504 --add-fstab) add_fstab_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
505 --mount) fstab_lines+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
506 --add-device|--device) add_device_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
507 --kernel-cmdline) kernel_cmdline_l+=("$2"); PARMS_TO_STORE+=" '$2'"; shift;;
25b45979 508 --nofscks) nofscks_l="yes";;
ff3953ef 509 --ro-mnt) ro_mnt_l="yes";;
659dc319
HB
510 -k|--kmoddir) drivers_dir_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
511 -c|--conf) conffile="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
512 --confdir) confdir="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
513 --tmpdir) tmpdir_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
514 -L|--stdlog) stdloglvl_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
515 --compress) compress_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
516 --prefix) prefix_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
37383f71 517 --loginstall) loginstall_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
659dc319
HB
518 --rebuild) if [ $rebuild_file == $outfile ]; then
519 force=yes
520 fi
521 shift
522 ;;
cc02093d
HH
523 -f|--force) force=yes;;
524 --kernel-only) kernel_only="yes"; no_kernel="no";;
525 --no-kernel) kernel_only="no"; no_kernel="yes";;
ab9457ef
HH
526 --print-cmdline)
527 print_cmdline="yes"; hostonly_l="yes"; kernel_only="yes"; no_kernel="yes";;
528 --early-microcode)
529 early_microcode_l="yes";;
530 --no-early-microcode)
531 early_microcode_l="no";;
cc02093d
HH
532 --strip) do_strip_l="yes";;
533 --nostrip) do_strip_l="no";;
04d18f55
HH
534 --hardlink) do_hardlink_l="yes";;
535 --nohardlink) do_hardlink_l="no";;
fd786adc 536 --noprefix) prefix_l="/";;
690396a5
VL
537 --mdadmconf) mdadmconf_l="yes";;
538 --nomdadmconf) mdadmconf_l="no";;
539 --lvmconf) lvmconf_l="yes";;
540 --nolvmconf) lvmconf_l="no";;
cc02093d 541 --debug) debug="yes";;
57258a2c 542 --profile) profile="yes";;
659dc319 543 --sshkey) sshkey="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
ee54b840 544 --logfile) logfile_l="$2"; shift;;
432196ae
545 -v|--verbose) ((verbosity_mod_l++));;
546 -q|--quiet) ((verbosity_mod_l--));;
dbf8f6ba
HH
547 -l|--local)
548 allowlocal="yes"
777f2db0 549 [[ -f "$(readlink -f "${0%/*}")/dracut-init.sh" ]] \
b093aa2d 550 && dracutbasedir="$(readlink -f "${0%/*}")"
dbf8f6ba 551 ;;
ea3c4e82
HH
552 -H|--hostonly|--host-only)
553 hostonly_l="yes" ;;
554 -N|--no-hostonly|--no-host-only)
555 hostonly_l="no" ;;
a695250e
KS
556 --hostonly-mode)
557 hostonly_mode_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
ab9457ef
HH
558 --hostonly-cmdline)
559 hostonly_cmdline_l="yes" ;;
b73e00af
HH
560 --hostonly-i18n)
561 i18n_install_all_l="no" ;;
562 --no-hostonly-i18n)
563 i18n_install_all_l="yes" ;;
ab9457ef
HH
564 --no-hostonly-cmdline)
565 hostonly_cmdline_l="no" ;;
37f2fe55
XP
566 --no-hostonly-default-device)
567 hostonly_default_device="no" ;;
324ea606 568 --persistent-policy)
659dc319 569 persistent_policy_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
cc02093d 570 --fstab) use_fstab_l="yes" ;;
ffa71b4a 571 -h|--help) long_usage; exit 1 ;;
5a66d511 572 -i|--include) include_src+=("$2"); PARMS_TO_STORE+=" '$2'";
ffa71b4a 573 shift;;
3a714439
VL
574 --bzip2) compress_l="bzip2";;
575 --lzma) compress_l="lzma";;
576 --xz) compress_l="xz";;
871c8e40 577 --lzo) compress_l="lzo";;
578 --lz4) compress_l="lz4";;
7dbadcc7 579 --zstd) compress_l="zstd";;
3a714439
VL
580 --no-compress) _no_compress_l="cat";;
581 --gzip) compress_l="gzip";;
ffa71b4a 582 --list-modules) do_list="yes";;
956af8f2
583 -M|--show-modules)
584 show_modules_l="yes"
585 ;;
5fe5c7d0 586 --keep) keep="yes";;
ec3c5951 587 --printsize) printsize="yes";;
7d848c55 588 --regenerate-all) regenerate_all="yes";;
83bb0893 589 --noimageifnotneeded) noimageifnotneeded="yes";;
80626ded 590 --reproducible) reproducible_l="yes";;
10f8df1b 591 --no-reproducible) reproducible_l="no";;
636d2d46
HH
592 --uefi) uefi="yes";;
593 --uefi-stub)
594 uefi_stub_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
595 --kernel-image)
596 kernel_image_l="$2"; PARMS_TO_STORE+=" '$2'"; shift;;
5c57209b
HH
597 --no-machineid)
598 machine_id_l="no";;
ffa71b4a
HH
599 --) shift; break;;
600
601 *) # should not even reach this point
602 printf "\n!Unknown option: '%s'\n\n" "$1" >&2; usage; exit 1;;
603 esac
604 shift
605done
606
607# getopt cannot handle multiple arguments, so just handle "-I,--include"
608# the old fashioned way
609
610while (($# > 0)); do
4eec1a22 611 if [ "${1%%=*}" == "++include" ]; then
5a66d511
HH
612 include_src+=("$2")
613 include_target+=("$3")
659dc319
HB
614 PARMS_TO_STORE+=" --include '$2' '$3'"
615 shift 2
616 fi
b368a5f3 617 shift
641cc356 618done
ffa71b4a 619
7d848c55
HH
620if [[ $regenerate_all == "yes" ]]; then
621 ret=0
622 if [[ $kernel ]]; then
b093aa2d 623 printf -- "--regenerate-all cannot be called with a kernel version\n" >&2
7d848c55
HH
624 exit 1
625 fi
626
627 if [[ $outfile ]]; then
b093aa2d 628 printf -- "--regenerate-all cannot be called with a image file\n" >&2
7d848c55
HH
629 exit 1
630 fi
631
632 ((len=${#dracut_args[@]}))
633 for ((i=0; i < len; i++)); do
634 [[ ${dracut_args[$i]} == "--regenerate-all" ]] && \
635 unset dracut_args[$i]
636 done
637
638 cd /lib/modules
639 for i in *; do
b29cb516 640 [[ -f $i/modules.dep ]] || [[ -f $i/modules.dep.bin ]] || continue
e8f19bcf 641 "$dracut_cmd" --kver="$i" "${dracut_args[@]}"
7d848c55
HH
642 ((ret+=$?))
643 done
644 exit $ret
645fi
646
8a5354a9 647if ! [[ $kernel ]]; then
486a1b93
HH
648 kernel=$(uname -r)
649fi
ffa71b4a 650
02b5c8e3
HH
651export LC_ALL=C
652export LANG=C
8a32bf61
HH
653unset LC_MESSAGES
654unset LC_CTYPE
d619fb5e 655unset LD_LIBRARY_PATH
45404a2a 656unset LD_PRELOAD
1fcf2d2f 657unset GREP_OPTIONS
a55711cd 658
89d44e72 659export DRACUT_LOG_LEVEL=warning
3b403b32 660[[ $debug ]] && {
89d44e72 661 export DRACUT_LOG_LEVEL=debug
c36ce334
VL
662 export PS4='${BASH_SOURCE}@${LINENO}(${FUNCNAME[0]}): ';
663 set -x
664}
665
57258a2c
HH
666[[ $profile ]] && {
667 export PS4='+ $(date "+%s.%N") ${BASH_SOURCE}@${LINENO}: ';
668 set -x
669 debug=yes
670}
671
c5a65990 672[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
5d791c0e 673
f1336ac7 674# if we were not passed a config file, try the default one
42c71947 675if [[ ! -f $conffile ]]; then
b093aa2d
HH
676 if [[ $allowlocal ]]; then
677 conffile="$dracutbasedir/dracut.conf"
678 else
eebc929a 679 conffile="/etc/dracut.conf"
b093aa2d 680 fi
42c71947 681fi
f1336ac7 682
2c2c4580 683if [[ ! -d $confdir ]]; then
b093aa2d
HH
684 if [[ $allowlocal ]]; then
685 confdir="$dracutbasedir/dracut.conf.d"
686 else
eebc929a 687 confdir="/etc/dracut.conf.d"
b093aa2d 688 fi
2c2c4580
HH
689fi
690
2245f372
AB
691# source our config file
692[[ -f $conffile ]] && . "$conffile"
693
2c2c4580 694# source our config dir
335bc217 695for f in $(dropindirs_sort ".conf" "$confdir" "$dracutbasedir/dracut.conf.d"); do
a42b2b81
HH
696 [[ -e $f ]] && . "$f"
697done
2c2c4580 698
5f2baf7d 699DRACUT_PATH=${DRACUT_PATH:-/sbin /bin /usr/sbin /usr/bin}
eab9b75c
HH
700
701for i in $DRACUT_PATH; do
702 rl=$i
703 if [ -L "$i" ]; then
704 rl=$(readlink -f $i)
705 fi
706 if [[ "$NPATH" != *:$rl* ]] ; then
707 NPATH+=":$rl"
708 fi
709done
710export PATH="${NPATH#:}"
711unset NPATH
712
cb0913db
HH
713# these options add to the stuff in the config file
714(( ${#add_dracutmodules_l[@]} )) && add_dracutmodules+=" ${add_dracutmodules_l[@]} "
715(( ${#force_add_dracutmodules_l[@]} )) && force_add_dracutmodules+=" ${force_add_dracutmodules_l[@]} "
716(( ${#fscks_l[@]} )) && fscks+=" ${fscks_l[@]} "
717(( ${#add_fstab_l[@]} )) && add_fstab+=" ${add_fstab_l[@]} "
718(( ${#fstab_lines_l[@]} )) && fstab_lines+=( "${fstab_lines_l[@]}" )
719(( ${#install_items_l[@]} )) && install_items+=" ${install_items_l[@]} "
720(( ${#install_optional_items_l[@]} )) && install_optional_items+=" ${install_optional_items_l[@]} "
54b68829 721
f1336ac7 722# these options override the stuff in the config file
cb0913db
HH
723(( ${#dracutmodules_l[@]} )) && dracutmodules="${dracutmodules_l[@]}"
724(( ${#omit_dracutmodules_l[@]} )) && omit_dracutmodules="${omit_dracutmodules_l[@]}"
725(( ${#filesystems_l[@]} )) && filesystems="${filesystems_l[@]}"
726(( ${#fw_dir_l[@]} )) && fw_dir="${fw_dir_l[@]}"
727(( ${#libdirs_l[@]} ))&& libdirs="${libdirs_l[@]}"
c9143a63 728
e103615b 729[[ $stdloglvl_l ]] && stdloglvl=$stdloglvl_l
b991617f 730[[ ! $stdloglvl ]] && stdloglvl=4
432196ae
731stdloglvl=$((stdloglvl + verbosity_mod_l))
732((stdloglvl > 6)) && stdloglvl=6
733((stdloglvl < 0)) && stdloglvl=0
734
26537a5b 735[[ $drivers_dir_l ]] && drivers_dir=$drivers_dir_l
31f7db66 736[[ $do_strip_l ]] && do_strip=$do_strip_l
6c128565 737[[ $do_strip ]] || do_strip=yes
04d18f55
HH
738[[ $do_hardlink_l ]] && do_hardlink=$do_hardlink_l
739[[ $do_hardlink ]] || do_hardlink=yes
fd786adc
HH
740[[ $prefix_l ]] && prefix=$prefix_l
741[[ $prefix = "/" ]] && unset prefix
ba726310 742[[ $hostonly_l ]] && hostonly=$hostonly_l
ab9457ef 743[[ $hostonly_cmdline_l ]] && hostonly_cmdline=$hostonly_cmdline_l
a695250e 744[[ $hostonly_mode_l ]] && hostonly_mode=$hostonly_mode_l
30f6c80d 745[[ "$hostonly" == "yes" ]] && ! [[ $hostonly_cmdline ]] && hostonly_cmdline="yes"
b73e00af 746[[ $i18n_install_all_l ]] && i18n_install_all=$i18n_install_all_l
3411ad66 747[[ $persistent_policy_l ]] && persistent_policy=$persistent_policy_l
7c179686 748[[ $use_fstab_l ]] && use_fstab=$use_fstab_l
2f02ae9d 749[[ $mdadmconf_l ]] && mdadmconf=$mdadmconf_l
7a34efa5 750[[ $lvmconf_l ]] && lvmconf=$lvmconf_l
c5a65990 751[[ $dracutbasedir ]] || dracutbasedir=/usr/lib/dracut
794b2d2c 752[[ $fw_dir ]] || fw_dir="/lib/firmware/updates:/lib/firmware:/lib/firmware/$kernel"
882c4c5a
753[[ $tmpdir_l ]] && tmpdir="$tmpdir_l"
754[[ $tmpdir ]] || tmpdir=/var/tmp
871c8e40 755[[ $INITRD_COMPRESS ]] && compress=$INITRD_COMPRESS
3a714439 756[[ $compress_l ]] && compress=$compress_l
956af8f2 757[[ $show_modules_l ]] && show_modules=$show_modules_l
25b45979 758[[ $nofscks_l ]] && nofscks="yes"
ff3953ef 759[[ $ro_mnt_l ]] && ro_mnt="yes"
b7c770e1 760[[ $early_microcode_l ]] && early_microcode=$early_microcode_l
b25ef46f 761[[ $early_microcode ]] || early_microcode=yes
ee54b840 762[[ $logfile_l ]] && logfile="$logfile_l"
80626ded 763[[ $reproducible_l ]] && reproducible="$reproducible_l"
37383f71 764[[ $loginstall_l ]] && loginstall="$loginstall_l"
636d2d46
HH
765[[ $uefi_stub_l ]] && uefi_stub="$uefi_stub_l"
766[[ $kernel_image_l ]] && kernel_image="$kernel_image_l"
5c57209b
HH
767[[ $machine_id_l ]] && machine_id="$machine_id_l"
768
769if ! [[ $outfile ]]; then
770 if [[ $machine_id != "no" ]]; then
771 [[ -f /etc/machine-id ]] && read MACHINE_ID < /etc/machine-id
772 fi
773
774 if [[ $uefi == "yes" ]]; then
5a962b59
MR
775 if [[ -n "$uefi_secureboot_key" && -z "$uefi_secureboot_cert" ]] || [[ -z $uefi_secureboot_key && -n $uefi_secureboot_cert ]]; then
776 dfatal "Need 'uefi_secureboot_key' and 'uefi_secureboot_cert' both to be set."
777 exit 1
778 fi
779
780 if [[ -n "$uefi_secureboot_key" && -n "$uefi_secureboot_cert" ]] && !command -v sbsign &>/dev/null; then
781 dfatal "Need 'sbsign' to create a signed UEFI executable"
782 exit 1
783 fi
784
5c57209b
HH
785 BUILD_ID=$(cat /etc/os-release /usr/lib/os-release \
786 | while read -r line || [[ $line ]]; do \
787 [[ $line =~ BUILD_ID\=* ]] && eval "$line" && echo "$BUILD_ID" && break; \
788 done)
789 if [[ -d /efi ]] && mountpoint -q /efi; then
305c6f91 790 efidir=/efi/EFI
5c57209b
HH
791 else
792 efidir=/boot/EFI
793 if [[ -d /boot/efi/EFI ]] && mountpoint -q /boot/efi; then
794 efidir=/boot/efi/EFI
795 fi
796 fi
797 mkdir -p "$efidir/Linux"
798 outfile="$efidir/Linux/linux-$kernel${MACHINE_ID:+-${MACHINE_ID}}${BUILD_ID:+-${BUILD_ID}}.efi"
799 else
791d8016
HH
800 if [[ -e "/boot/vmlinuz-$kernel" ]]; then
801 outfile="/boot/initramfs-$kernel.img"
802 elif [[ $MACHINE_ID ]] && ( [[ -d /boot/${MACHINE_ID} ]] || [[ -L /boot/${MACHINE_ID} ]] ); then
5c57209b
HH
803 outfile="/boot/${MACHINE_ID}/$kernel/initrd"
804 else
805 outfile="/boot/initramfs-$kernel.img"
806 fi
807 fi
808fi
80626ded 809
ddfd1d10 810# eliminate IFS hackery when messing with fw_dir
794b2d2c 811export DRACUT_FIRMWARE_PATH=${fw_dir// /:}
ddfd1d10 812fw_dir=${fw_dir//:/ }
9a8a00cf 813
3838dc47 814# check for logfile and try to create one if it doesn't exist
815if [[ -n "$logfile" ]];then
816 if [[ ! -f "$logfile" ]];then
817 touch "$logfile"
818 if [ ! $? -eq 0 ] ;then
819 printf "%s\n" "dracut: touch $logfile failed." >&2
820 fi
821 fi
822fi
823
3a714439 824# handle compression options.
693b7a32
HH
825if [[ $_no_compress_l = "cat" ]]; then
826 compress="cat"
827fi
828
829if ! [[ $compress ]]; then
830 # check all known compressors, if none specified
7dbadcc7 831 for i in pigz gzip lz4 lzop zstd lzma xz lbzip2 bzip2 cat; do
693b7a32
HH
832 command -v "$i" &>/dev/null || continue
833 compress="$i"
834 break
835 done
836 if [[ $compress = cat ]]; then
837 printf "%s\n" "dracut: no compression tool available. Initramfs image is going to be big." >&2
838 fi
839fi
840
841# choose the right arguments for the compressor
3a714439 842case $compress in
693b7a32
HH
843 bzip2|lbzip2)
844 if [[ "$compress" = lbzip2 ]] || command -v lbzip2 &>/dev/null; then
845 compress="lbzip2 -9"
846 else
847 compress="bzip2 -9"
848 fi
849 ;;
850 lzma)
851 compress="lzma -9 -T0"
852 ;;
853 xz)
854 compress="xz --check=crc32 --lzma2=dict=1MiB -T0"
855 ;;
856 gzip|pigz)
857 if [[ "$compress" = pigz ]] || command -v pigz &>/dev/null; then
66fd7e43 858 compress="pigz -9 -n -T -R"
693b7a32 859 elif command -v gzip &>/dev/null && gzip --help 2>&1 | grep -q rsyncable; then
66fd7e43 860 compress="gzip -n -9 --rsyncable"
693b7a32
HH
861 else
862 compress="gzip -n -9"
66fd7e43
HH
863 fi
864 ;;
693b7a32
HH
865 lzo|lzop)
866 compress="lzop -9"
867 ;;
868 lz4)
869 compress="lz4 -l -9"
870 ;;
7dbadcc7
TPG
871 zstd)
872 compress="zstd -15 -q -T0"
873 ;;
3a714439 874esac
3a714439 875
ba726310 876[[ $hostonly = yes ]] && hostonly="-h"
ba67b923 877[[ $hostonly != "-h" ]] && unset hostonly
ba726310 878
a695250e
KS
879case $hostonly_mode in
880 '')
881 [[ $hostonly ]] && hostonly_mode="sloppy" ;;
882 sloppy|strict)
883 if [[ ! $hostonly ]]; then
884 unset hostonly_mode
885 fi
886 ;;
887 *)
888 printf "%s\n" "dracut: Invalid hostonly mode '$hostonly_mode'." >&2
889 exit 1
890esac
891
80626ded
HH
892[[ $reproducible == yes ]] && DRACUT_REPRODUCIBLE=1
893
bafc82e7
DD
894readonly TMPDIR="$(realpath -e "$tmpdir")"
895[ -d "$TMPDIR" ] || {
896 printf "%s\n" "dracut: Invalid tmpdir '$tmpdir'." >&2
897 exit 1
898}
62c00a88
HH
899readonly DRACUT_TMPDIR="$(mktemp -p "$TMPDIR/" -d -t dracut.XXXXXX)"
900[ -d "$DRACUT_TMPDIR" ] || {
901 printf "%s\n" "dracut: mktemp -p '$TMPDIR/' -d -t dracut.XXXXXX failed." >&2
26c231f1
HH
902 exit 1
903}
904
d008b6b8 905# clean up after ourselves no matter how we die.
bbaa0d59
HH
906trap '
907 ret=$?;
62c00a88 908 [[ $keep ]] && echo "Not removing $DRACUT_TMPDIR." >&2 || { [[ $DRACUT_TMPDIR ]] && rm -rf -- "$DRACUT_TMPDIR"; };
bbaa0d59
HH
909 exit $ret;
910 ' EXIT
911
d008b6b8
HH
912# clean up after ourselves no matter how we die.
913trap 'exit 1;' SIGINT
914
3889234f
HH
915readonly initdir="${DRACUT_TMPDIR}/initramfs"
916mkdir "$initdir"
917
918if [[ $early_microcode = yes ]] || ( [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]] ); then
919 readonly early_cpio_dir="${DRACUT_TMPDIR}/earlycpio"
920 mkdir "$early_cpio_dir"
921fi
922
89d44e72
HH
923export DRACUT_RESOLVE_LAZY="1"
924
535f61ca
HH
925if [[ $print_cmdline ]]; then
926 stdloglvl=0
927 sysloglvl=0
928 fileloglvl=0
929 kmsgloglvl=0
930fi
931
e27ecc9a
HH
932if [[ -f $dracutbasedir/dracut-version.sh ]]; then
933 . $dracutbasedir/dracut-version.sh
934fi
935
777f2db0
HH
936if [[ -f $dracutbasedir/dracut-init.sh ]]; then
937 . $dracutbasedir/dracut-init.sh
adbc8a42 938else
777f2db0 939 printf "%s\n" "dracut: Cannot find $dracutbasedir/dracut-init.sh." >&2
b093aa2d 940 printf "%s\n" "dracut: Are you running from a git checkout?" >&2
e8f19bcf 941 printf "%s\n" "dracut: Try passing -l as an argument to $dracut_cmd" >&2
cc02093d 942 exit 1
adbc8a42 943fi
22fd1627 944
106255af
HH
945if [[ $no_kernel != yes ]] && ! [[ -d $srcmods ]]; then
946 printf "%s\n" "dracut: Cannot find module directory $srcmods" >&2
947 printf "%s\n" "dracut: and --no-kernel was not specified" >&2
948 exit 1
949fi
950
1743473b
HH
951if ! [[ $print_cmdline ]]; then
952 inst /bin/sh
ffc68f35 953 if ! $DRACUT_INSTALL ${initdir:+-D "$initdir"} -R "$initdir/bin/sh" &>/dev/null; then
1743473b
HH
954 unset DRACUT_RESOLVE_LAZY
955 export DRACUT_RESOLVE_DEPS=1
956 fi
957 rm -fr -- ${initdir}/*
bfd2e8c2 958fi
bfd2e8c2 959
552ecca6 960dracutfunctions=$dracutbasedir/dracut-functions.sh
5cad5bb5 961export dracutfunctions
9a8a00cf 962
cb0913db 963(( ${#drivers_l[@]} )) && drivers="${drivers_l[@]}"
fcbcb252
HH
964drivers=${drivers/-/_}
965
cb0913db 966(( ${#add_drivers_l[@]} )) && add_drivers+=" ${add_drivers_l[@]} "
fcbcb252
HH
967add_drivers=${add_drivers/-/_}
968
cb0913db 969(( ${#force_drivers_l[@]} )) && force_drivers+=" ${force_drivers_l[@]} "
cea907f6
TR
970force_drivers=${force_drivers/-/_}
971
cb0913db 972(( ${#omit_drivers_l[@]} )) && omit_drivers+=" ${omit_drivers_l[@]} "
fcbcb252
HH
973omit_drivers=${omit_drivers/-/_}
974
cb0913db 975(( ${#kernel_cmdline_l[@]} )) && kernel_cmdline+=" ${kernel_cmdline_l[@]} "
d20fb951 976
34248c92 977omit_drivers_corrected=""
fcbcb252 978for d in $omit_drivers; do
b093aa2d 979 [[ " $drivers $add_drivers " == *\ $d\ * ]] && continue
cea907f6 980 [[ " $drivers $force_drivers " == *\ $d\ * ]] && continue
34248c92 981 omit_drivers_corrected+="$d|"
fcbcb252 982done
34248c92 983omit_drivers="${omit_drivers_corrected%|}"
fcbcb252
HH
984unset omit_drivers_corrected
985
ffa71b4a
HH
986# prepare args for logging
987for ((i=0; i < ${#dracut_args[@]}; i++)); do
b093aa2d 988 [[ "${dracut_args[$i]}" == *\ * ]] && \
ffa71b4a 989 dracut_args[$i]="\"${dracut_args[$i]}\""
a4210166 990 #" keep vim happy
ffa71b4a 991done
535f61ca 992
e8f19bcf 993dinfo "Executing: $dracut_cmd ${dracut_args[@]}"
58dad702 994
5b11bb73
HH
995[[ $do_list = yes ]] && {
996 for mod in $dracutbasedir/modules.d/*; do
997 [[ -d $mod ]] || continue;
d8e8e14e
998 [[ -e $mod/install || -e $mod/installkernel || \
999 -e $mod/module-setup.sh ]] || continue
b093aa2d 1000 printf "%s\n" "${mod##*/??}"
5b11bb73
HH
1001 done
1002 exit 0
1003}
1004
66ac3cd1 1005# This is kinda legacy -- eventually it should go away.
f1336ac7 1006case $dracutmodules in
66ac3cd1 1007 ""|auto) dracutmodules="all" ;;
f1336ac7 1008esac
e12aac5e 1009
454771cd 1010abs_outfile=$(readlink -f "$outfile") && outfile="$abs_outfile"
ec9315e5 1011
c8b35bf9
ДГ
1012
1013[[ -d $systemdutildir ]] \
1014 || systemdutildir=$(pkg-config systemd --variable=systemdutildir 2>/dev/null)
1015
1016if ! [[ -d "$systemdutildir" ]]; then
1017 [[ -e /lib/systemd/systemd-udevd ]] && systemdutildir=/lib/systemd
1018 [[ -e /usr/lib/systemd/systemd-udevd ]] && systemdutildir=/usr/lib/systemd
1019fi
1020
1021
693b7a32
HH
1022if [[ $no_kernel != yes ]] && [[ -d $srcmods ]]; then
1023 if ! [[ -f $srcmods/modules.dep ]]; then
b019952f
HH
1024 if [[ -n "$(find "$srcmods" -name '*.ko*')" ]]; then
1025 dfatal "$srcmods/modules.dep is missing. Did you run depmod?"
1026 exit 1
1027 else
1028 dwarn "$srcmods/modules.dep is missing. Did you run depmod?"
1029 fi
693b7a32
HH
1030 elif ! ( command -v gzip &>/dev/null && command -v xz &>/dev/null); then
1031 read _mod < $srcmods/modules.dep
1032 _mod=${_mod%%:*}
1033 if [[ -f $srcmods/"$_mod" ]]; then
1034 # Check, if kernel modules are compressed, and if we can uncompress them
1035 case "$_mod" in
1036 *.ko.gz) kcompress=gzip;;
1037 *.ko.xz) kcompress=xz;;
1038 esac
1039 if [[ $kcompress ]]; then
1040 if ! command -v "$kcompress" &>/dev/null; then
1041 dfatal "Kernel modules are compressed with $kcompress, but $kcompress is not available."
1042 exit 1
1043 fi
1044 fi
1045 fi
1046 fi
5db6ca5a 1047fi
fe1484f3 1048
96cf7270
HH
1049if [[ ! $print_cmdline ]]; then
1050 if [[ -f $outfile && ! $force ]]; then
1051 dfatal "Will not override existing initramfs ($outfile) without --force"
1052 exit 1
1053 fi
1054
1055 outdir=${outfile%/*}
1056 [[ $outdir ]] || outdir="/"
1057
1058 if [[ ! -d "$outdir" ]]; then
1059 dfatal "Can't write to $outdir: Directory $outdir does not exist or is not accessible."
1060 exit 1
1061 elif [[ ! -w "$outdir" ]]; then
1062 dfatal "No permission to write to $outdir."
1063 exit 1
1064 elif [[ -f "$outfile" && ! -w "$outfile" ]]; then
1065 dfatal "No permission to write $outfile."
1066 exit 1
1067 fi
37383f71
HH
1068
1069 if [[ $loginstall ]]; then
1070 if ! mkdir -p "$loginstall"; then
1071 dfatal "Could not create directory to log installed files to '$loginstall'."
1072 exit 1
1073 fi
1074 loginstall=$(readlink -f "$loginstall")
1075 fi
636d2d46
HH
1076
1077 if [[ $uefi = yes ]]; then
1078 if ! command -v objcopy &>/dev/null; then
1079 dfatal "Need 'objcopy' to create a UEFI executable"
1080 exit 1
1081 fi
1082 unset EFI_MACHINE_TYPE_NAME
12f023ab 1083 case $(uname -m) in
636d2d46
HH
1084 x86_64)
1085 EFI_MACHINE_TYPE_NAME=x64;;
1086 ia32)
1087 EFI_MACHINE_TYPE_NAME=ia32;;
1088 *)
12f023ab 1089 dfatal "Architecture '$(uname -m)' not supported to create a UEFI executable"
636d2d46
HH
1090 exit 1
1091 ;;
1092 esac
1093
1094 if ! [[ -s $uefi_stub ]]; then
1095 for uefi_stub in \
53475faa 1096 "${systemdutildir}/boot/efi/linux${EFI_MACHINE_TYPE_NAME}.efi.stub" \
636d2d46
HH
1097 "/usr/lib/gummiboot/linux${EFI_MACHINE_TYPE_NAME}.efi.stub"; do
1098 [[ -s $uefi_stub ]] || continue
1099 break
1100 done
1101 fi
1102 if ! [[ -s $uefi_stub ]]; then
1103 dfatal "Can't find a uefi stub '$uefi_stub' to create a UEFI executable"
1104 exit 1
1105 fi
1106
1107 if ! [[ $kernel_image ]]; then
1108 for kernel_image in "/lib/modules/$kernel/vmlinuz" "/boot/vmlinuz-$kernel"; do
1109 [[ -s "$kernel_image" ]] || continue
1110 break
1111 done
1112 fi
1113 if ! [[ -s $kernel_image ]]; then
1114 dfatal "Can't find a kernel image '$kernel_image' to create a UEFI executable"
1115 exit 1
1116 fi
1117 fi
ec9315e5
JK
1118fi
1119
940169e8
HH
1120if [[ $acpi_override = yes ]] && ! ( check_kernel_config CONFIG_ACPI_TABLE_UPGRADE || check_kernel_config CONFIG_ACPI_INITRD_TABLE_OVERRIDE ); then
1121 dwarn "Disabling ACPI override, because kernel does not support it. CONFIG_ACPI_INITRD_TABLE_OVERRIDE!=y or CONFIG_ACPI_TABLE_UPGRADE!=y"
8e3f6537
HH
1122 unset acpi_override
1123fi
1124
1125if [[ $early_microcode = yes ]]; then
1126 if [[ $hostonly ]]; then
1127 [[ $(get_cpu_vendor) == "AMD" ]] \
875426f2 1128 && ! check_kernel_config CONFIG_MICROCODE_AMD \
8e3f6537
HH
1129 && unset early_microcode
1130 [[ $(get_cpu_vendor) == "Intel" ]] \
875426f2 1131 && ! check_kernel_config CONFIG_MICROCODE_INTEL \
8e3f6537
HH
1132 && unset early_microcode
1133 else
875426f2
HH
1134 ! check_kernel_config CONFIG_MICROCODE_AMD \
1135 && ! check_kernel_config CONFIG_MICROCODE_INTEL \
8e3f6537
HH
1136 && unset early_microcode
1137 fi
1138 [[ $early_microcode != yes ]] \
875426f2 1139 && dwarn "Disabling early microcode, because kernel does not support it. CONFIG_MICROCODE_[AMD|INTEL]!=y"
8e3f6537
HH
1140fi
1141
f6f74096
DD
1142# Need to be able to have non-root users read stuff (rpcbind etc)
1143chmod 755 "$initdir"
1144
5bfa3b36
HH
1145if [[ $hostonly ]]; then
1146 for i in /sys /proc /run /dev; do
5e601454 1147 if ! findmnt --target "$i" &>/dev/null; then
5bfa3b36
HH
1148 dwarning "Turning off host-only mode: '$i' is not mounted!"
1149 unset hostonly
1150 fi
1151 done
1152fi
1153
d351541e
HH
1154declare -A host_fs_types
1155
cd7ff122
AW
1156for line in "${fstab_lines[@]}"; do
1157 set -- $line
6df52351 1158 dev="$1"
cd7ff122 1159 #dev mp fs fsopts
6df52351
TR
1160 case "$dev" in
1161 UUID=*)
1162 dev=$(blkid -l -t UUID=${dev#UUID=} -o device)
1163 ;;
1164 LABEL=*)
1165 dev=$(blkid -l -t LABEL=${dev#LABEL=} -o device)
1166 ;;
1167 PARTUUID=*)
1168 dev=$(blkid -l -t PARTUUID=${dev#PARTUUID=} -o device)
1169 ;;
1170 PARTLABEL=*)
1171 dev=$(blkid -l -t PARTLABEL=${dev#PARTLABEL=} -o device)
1172 ;;
1173 esac
1174 [ -z "$dev" ] && dwarn "Bad fstab entry $@" && continue
1cadc26f
HH
1175 if [[ "$3" == btrfs ]]; then
1176 for i in $(btrfs_devs "$2"); do
1177 push_host_devs "$i"
1178 done
1179 fi
6df52351
TR
1180 push_host_devs "$dev"
1181 host_fs_types["$dev"]="$3"
cd7ff122
AW
1182done
1183
1184for f in $add_fstab; do
b093aa2d 1185 [[ -e $f ]] || continue
6d58fa27 1186 while read dev rest || [ -n "$dev" ]; do
118ca9ec 1187 push_host_devs "$dev"
b093aa2d
HH
1188 done < "$f"
1189done
1190
1191for dev in $add_device; do
118ca9ec 1192 push_host_devs "$dev"
cd7ff122
AW
1193done
1194
c586b033 1195if (( ${#add_device_l[@]} )); then
694725ab
HH
1196 add_device+=" ${add_device_l[@]} "
1197 push_host_devs "${add_device_l[@]}"
c586b033
CG
1198fi
1199
37f2fe55 1200if [[ $hostonly ]] && [[ "$hostonly_default_device" != "no" ]]; then
480d772f
HH
1201 # in hostonly mode, determine all devices, which have to be accessed
1202 # and examine them for filesystem types
1203
bcfbddef 1204 for mp in \
7ae5d9d1
HH
1205 "/" \
1206 "/etc" \
d624f606
HH
1207 "/bin" \
1208 "/sbin" \
1209 "/lib" \
1210 "/lib64" \
af75a298 1211 "/usr" \
9fc14445
HH
1212 "/usr/bin" \
1213 "/usr/sbin" \
1214 "/usr/lib" \
1215 "/usr/lib64" \
a956a464
HH
1216 "/boot" \
1217 "/boot/efi" \
33260dac 1218 "/boot/zipl" \
a956a464 1219 ;
bcfbddef 1220 do
d624f606 1221 mp=$(readlink -f "$mp")
7ae5d9d1 1222 mountpoint "$mp" >/dev/null 2>&1 || continue
a4f7b504 1223 _dev=$(find_block_device "$mp")
e95b6723 1224 _bdev=$(readlink -f "/dev/block/$_dev")
a4f7b504 1225 [[ -b $_bdev ]] && _dev=$_bdev
5a66d511 1226 [[ "$mp" == "/" ]] && root_devs+=("$_dev")
118ca9ec 1227 push_host_devs "$_dev"
1cadc26f
HH
1228 if [[ $(find_mp_fstype "$mp") == btrfs ]]; then
1229 for i in $(btrfs_devs "$mp"); do
5a66d511 1230 [[ "$mp" == "/" ]] && root_devs+=("$i")
1cadc26f
HH
1231 push_host_devs "$i"
1232 done
1233 fi
7ae5d9d1 1234 done
dd587549 1235
7fd850d5 1236 if [[ -f /proc/swaps ]] && [[ -f /etc/fstab ]]; then
6d58fa27 1237 while read dev type rest || [ -n "$dev" ]; do
7fd850d5
HH
1238 [[ -b $dev ]] || continue
1239 [[ "$type" == "partition" ]] || continue
1240
6d58fa27 1241 while read _d _m _t _o _r || [ -n "$_d" ]; do
7fd850d5
HH
1242 [[ "$_d" == \#* ]] && continue
1243 [[ $_d ]] || continue
546d5dac
HH
1244 [[ $_t != "swap" ]] && continue
1245 [[ $_m != "swap" ]] && [[ $_m != "none" ]] && continue
7fd850d5 1246 [[ "$_o" == *noauto* ]] && continue
c82a1133 1247 _d=$(expand_persistent_dev "$_d")
7fd850d5
HH
1248 [[ "$_d" -ef "$dev" ]] || continue
1249
1250 if [[ -f /etc/crypttab ]]; then
6d58fa27 1251 while read _mapper _a _p _o || [ -n "$_mapper" ]; do
7fd850d5
HH
1252 [[ $_mapper = \#* ]] && continue
1253 [[ "$_d" -ef /dev/mapper/"$_mapper" ]] || continue
1254 [[ "$_o" ]] || _o="$_p"
64ae4e07
HH
1255 # skip entries with password files
1256 [[ "$_p" == /* ]] && [[ -f $_p ]] && continue 2
1743473b 1257 # skip mkswap swap
7fd850d5
HH
1258 [[ $_o == *swap* ]] && continue 2
1259 done < /etc/crypttab
1260 fi
bcfbddef 1261
3e3ed34f
CG
1262 _dev="$(readlink -f "$dev")"
1263 push_host_devs "$_dev"
5a66d511 1264 swap_devs+=("$_dev")
7fd850d5
HH
1265 break
1266 done < /etc/fstab
1267 done < /proc/swaps
1268 fi
916559e0
HH
1269
1270 # collect all "x-initrd.mount" entries from /etc/fstab
1271 if [[ -f /etc/fstab ]]; then
1272 while read _d _m _t _o _r || [ -n "$_d" ]; do
1273 [[ "$_d" == \#* ]] && continue
1274 [[ $_d ]] || continue
1275 [[ "$_o" != *x-initrd.mount* ]] && continue
1276 _dev=$(expand_persistent_dev "$_d")
1277 _dev="$(readlink -f "$_dev")"
1cadc26f
HH
1278 [[ -b $_dev ]] || continue
1279
1280 push_host_devs "$_dev"
1281 if [[ "$_t" == btrfs ]]; then
bfa4e45f 1282 for i in $(btrfs_devs "$_m"); do
1cadc26f
HH
1283 push_host_devs "$i"
1284 done
1285 fi
916559e0
HH
1286 done < /etc/fstab
1287 fi
7ae5d9d1 1288fi
7ae5d9d1 1289
3c4315fa
HH
1290unset m
1291unset rest
1292
dba20559 1293_get_fs_type() {
19bab59c 1294 [[ $1 ]] || return
e41f3f90
HH
1295 if [[ -b /dev/block/$1 ]]; then
1296 ID_FS_TYPE=$(get_fs_env "/dev/block/$1") && host_fs_types["$(readlink -f "/dev/block/$1")"]="$ID_FS_TYPE"
19bab59c 1297 return 1
cd7ff122 1298 fi
e41f3f90
HH
1299 if [[ -b $1 ]]; then
1300 ID_FS_TYPE=$(get_fs_env "$1") && host_fs_types["$(readlink -f "$1")"]="$ID_FS_TYPE"
19bab59c 1301 return 1
4f10ae2b 1302 fi
b093aa2d 1303 if fstype=$(find_dev_fstype "$1"); then
dba20559 1304 host_fs_types["$1"]="$fstype"
19bab59c 1305 return 1
cd7ff122
AW
1306 fi
1307 return 1
dba20559
HH
1308}
1309
3721635b 1310for dev in "${host_devs[@]}"; do
dba20559
HH
1311 _get_fs_type "$dev"
1312 check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
cd7ff122
AW
1313done
1314
8df0b654
HH
1315for dev in "${!host_fs_types[@]}"; do
1316 [[ ${host_fs_types[$dev]} = "reiserfs" ]] || [[ ${host_fs_types[$dev]} = "xfs" ]] || continue
1317 rootopts=$(find_dev_fsopts "$dev")
1318 if [[ ${host_fs_types[$dev]} = "reiserfs" ]]; then
1319 journaldev=$(fs_get_option $rootopts "jdev")
1320 elif [[ ${host_fs_types[$dev]} = "xfs" ]]; then
1321 journaldev=$(fs_get_option $rootopts "logdev")
1322 fi
1323 if [[ $journaldev ]]; then
1324 dev="$(readlink -f "$dev")"
118ca9ec 1325 push_host_devs "$dev"
8df0b654
HH
1326 _get_fs_type "$dev"
1327 check_block_and_slaves_all _get_fs_type "$(get_maj_min "$dev")"
1328 fi
1329done
1330
d1615612 1331[[ -d $udevdir ]] \
b093aa2d 1332 || udevdir="$(pkg-config udev --variable=udevdir 2>/dev/null)"
d1615612 1333if ! [[ -d "$udevdir" ]]; then
dddcb809
HJ
1334 [[ -e /lib/udev/ata_id ]] && udevdir=/lib/udev
1335 [[ -e /usr/lib/udev/ata_id ]] && udevdir=/usr/lib/udev
d1615612
HH
1336fi
1337
cb8def95
HH
1338[[ -d $systemdsystemunitdir ]] \
1339 || systemdsystemunitdir=$(pkg-config systemd --variable=systemdsystemunitdir 2>/dev/null)
1340
d1615612
HH
1341[[ -d "$systemdsystemunitdir" ]] || systemdsystemunitdir=${systemdutildir}/system
1342
cb8def95
HH
1343[[ -d $systemdsystemconfdir ]] \
1344 || systemdsystemconfdir=$(pkg-config systemd --variable=systemdsystemconfdir 2>/dev/null)
1345
1346[[ -d "$systemdsystemconfdir" ]] || systemdsystemconfdir=/etc/systemd/system
1347
3a04bdde
HH
1348[[ -d $tmpfilesdir ]] \
1349 || tmpfilesdir=$(pkg-config systemd --variable=tmpfilesdir 2>/dev/null)
1350
1351if ! [[ -d "$tmpfilesdir" ]]; then
55b99a0e
CG
1352 [[ -d /lib/tmpfiles.d ]] && tmpfilesdir=/lib/tmpfiles.d
1353 [[ -d /usr/lib/tmpfiles.d ]] && tmpfilesdir=/usr/lib/tmpfiles.d
3a04bdde
HH
1354fi
1355
ab2f95e4
HH
1356export initdir dracutbasedir \
1357 dracutmodules force_add_dracutmodules add_dracutmodules omit_dracutmodules \
1358 mods_to_load \
e103615b 1359 fw_dir drivers_dir debug no_kernel kernel_only \
5634a311 1360 omit_drivers mdadmconf lvmconf root_devs \
ff3953ef 1361 use_fstab fstab_lines libdirs fscks nofscks ro_mnt \
1e64e493 1362 stdloglvl sysloglvl fileloglvl kmsgloglvl logfile \
3e3ed34f 1363 debug host_fs_types host_devs swap_devs sshkey add_fstab \
cb8def95 1364 DRACUT_VERSION udevdir prefix filesystems drivers \
3c4315fa 1365 systemdutildir systemdsystemunitdir systemdsystemconfdir \
3f60444e 1366 hostonly_cmdline loginstall \
3a04bdde 1367 tmpfilesdir
f4fff04e 1368
1743473b
HH
1369mods_to_load=""
1370# check all our modules to see if they should be sourced.
1371# This builds a list of modules that we will install next.
1372for_each_module_dir check_module
1373for_each_module_dir check_mount
1374
88c86ac7 1375dracut_module_included "fips" && export DRACUT_FIPS_MODE=1
1743473b 1376
91190597
HH
1377do_print_cmdline()
1378{
21a20973
HH
1379 local -A _mods_to_print
1380 for i in $modules_loaded $mods_to_load; do
1381 _mods_to_print[$i]=1
1382 done
1383
1743473b
HH
1384 # source our modules.
1385 for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
1386 _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
21a20973 1387 [[ ${_mods_to_print[$_d_mod]} ]] || continue
5916d31b 1388 module_cmdline "$_d_mod" "$moddir"
1743473b
HH
1389 done
1390 unset moddir
91190597
HH
1391}
1392
1393if [[ $print_cmdline ]]; then
1394 do_print_cmdline
a17d5cf4 1395 printf "\n"
1743473b
HH
1396 exit 0
1397fi
1398
dbad9f46 1399# Create some directory structure first
fd786adc 1400[[ $prefix ]] && mkdir -m 0755 -p "${initdir}${prefix}"
dbad9f46 1401
785a6cd2 1402[[ -h /lib ]] || mkdir -m 0755 -p "${initdir}${prefix}/lib"
fd786adc 1403[[ $prefix ]] && ln -sfn "${prefix#/}/lib" "$initdir/lib"
dbad9f46 1404
785a6cd2 1405if [[ $prefix ]]; then
d2a9c4a8 1406 for d in bin etc lib sbin tmp usr var $libdirs; do
b093aa2d 1407 [[ "$d" == */* ]] && continue
785a6cd2
HH
1408 ln -sfn "${prefix#/}/${d#/}" "$initdir/$d"
1409 done
1410fi
1411
1412if [[ $kernel_only != yes ]]; then
6f92423c 1413 for d in usr/bin usr/sbin bin etc lib sbin tmp usr var var/tmp $libdirs; do
fd786adc 1414 [[ -e "${initdir}${prefix}/$d" ]] && continue
d433da44
HH
1415 if [ -L "/$d" ]; then
1416 inst_symlink "/$d" "${prefix}/$d"
785a6cd2
HH
1417 else
1418 mkdir -m 0755 -p "${initdir}${prefix}/$d"
1419 fi
3b403b32 1420 done
dbad9f46 1421
8d89fc6b 1422 for d in dev proc sys sysroot root run; do
d433da44
HH
1423 if [ -L "/$d" ]; then
1424 inst_symlink "/$d"
785a6cd2
HH
1425 else
1426 mkdir -m 0755 -p "$initdir/$d"
1427 fi
33ee031c 1428 done
dbad9f46 1429
506b2192
HH
1430 ln -sfn ../run "$initdir/var/run"
1431 ln -sfn ../run/lock "$initdir/var/lock"
6f09acf8
HH
1432else
1433 for d in lib "$libdir"; do
1434 [[ -e "${initdir}${prefix}/$d" ]] && continue
1435 if [ -h "/$d" ]; then
1436 inst "/$d" "${prefix}/$d"
1437 else
1438 mkdir -m 0755 -p "${initdir}${prefix}/$d"
1439 fi
1440 done
33ee031c 1441fi
0f86847d 1442
14c47b0e
HH
1443if [[ $kernel_only != yes ]]; then
1444 mkdir -p "${initdir}/etc/cmdline.d"
4fed3ddf
HH
1445 for _d in $hookdirs; do
1446 mkdir -m 0755 -p ${initdir}/lib/dracut/hooks/$_d
1447 done
647b521f 1448 if [[ "$EUID" = "0" ]]; then
ad200fbc
HH
1449 [ -c ${initdir}/dev/null ] || mknod ${initdir}/dev/null c 1 3
1450 [ -c ${initdir}/dev/kmsg ] || mknod ${initdir}/dev/kmsg c 1 11
1451 [ -c ${initdir}/dev/console ] || mknod ${initdir}/dev/console c 5 1
83a6d6f9
HH
1452 [ -c ${initdir}/dev/random ] || mknod ${initdir}/dev/random c 1 8
1453 [ -c ${initdir}/dev/urandom ] || mknod ${initdir}/dev/urandom c 1 9
26144216 1454 fi
14c47b0e 1455fi
96b8d60a 1456
ec3c5951 1457_isize=0 #initramfs size
979c4a93 1458modules_loaded=" "
95bde758 1459# source our modules.
5d791c0e 1460for moddir in "$dracutbasedir/modules.d"/[0-9][0-9]*; do
979c4a93 1461 _d_mod=${moddir##*/}; _d_mod=${_d_mod#[0-9][0-9]}
bee08653
HH
1462 [[ "$mods_to_load" == *\ $_d_mod\ * ]] || continue
1463 if [[ $show_modules = yes ]]; then
1464 printf "%s\n" "$_d_mod"
1465 else
1466 dinfo "*** Including module: $_d_mod ***"
1467 fi
1468 if [[ $kernel_only == yes ]]; then
5916d31b 1469 module_installkernel "$_d_mod" "$moddir" || {
bee08653
HH
1470 dfatal "installkernel failed in module $_d_mod"
1471 exit 1
1472 }
1473 else
5916d31b 1474 module_install "$_d_mod" "$moddir"
bee08653 1475 if [[ $no_kernel != yes ]]; then
5916d31b 1476 module_installkernel "$_d_mod" "$moddir" || {
a6d3be9d
AW
1477 dfatal "installkernel failed in module $_d_mod"
1478 exit 1
1479 }
ec3c5951 1480 fi
66ac3cd1 1481 fi
bee08653
HH
1482 mods_to_load=${mods_to_load// $_d_mod /}
1483 modules_loaded+="$_d_mod "
1484
1485 #print the module install size
1486 if [ -n "$printsize" ]; then
1487 _isize_new=$(du -sk ${initdir}|cut -f1)
1488 _isize_delta=$((_isize_new - _isize))
1489 printf "%s\n" "$_d_mod install size: ${_isize_delta}k"
1490 _isize=$_isize_new
1491 fi
15136762 1492done
20abd914 1493unset moddir
0a35a80b
HH
1494
1495for i in $modules_loaded; do
43fed151 1496 mkdir -p $initdir/lib/dracut
b093aa2d 1497 printf "%s\n" "$i" >> $initdir/lib/dracut/modules.txt
0a35a80b
HH
1498done
1499
ea216a65 1500dinfo "*** Including modules done ***"
aabc0553 1501
0f86847d 1502## final stuff that has to happen
89d44e72 1503if [[ $no_kernel != yes ]]; then
70472946 1504 if [[ $hostonly ]]; then
a0d9ad6f 1505 cp "$DRACUT_KERNEL_MODALIASES" $initdir/lib/dracut/hostonly-kernel-modules.txt
70472946 1506 fi
aec9f902
HH
1507
1508 if [[ $drivers ]]; then
1509 hostonly='' instmods $drivers
1510 fi
1511
d53bb5c0 1512 if [[ -n "${add_drivers// }" ]]; then
aec9f902
HH
1513 hostonly='' instmods -c $add_drivers
1514 fi
cea907f6
TR
1515 if [[ $force_drivers ]]; then
1516 hostonly='' instmods -c $force_drivers
1517 rm -f $initdir/etc/cmdline.d/20-force_driver.conf
1518 for mod in $force_drivers; do
1519 echo "rd.driver.pre=$mod" >>$initdir/etc/cmdline.d/20-force_drivers.conf
1520 done
1521 fi
aec9f902
HH
1522 if [[ $filesystems ]]; then
1523 hostonly='' instmods -c $filesystems
1524 fi
1525
794b2d2c 1526 dinfo "*** Installing kernel module dependencies ***"
89d44e72 1527 dracut_kernel_post
794b2d2c 1528 dinfo "*** Installing kernel module dependencies done ***"
83bb0893
HH
1529
1530 if [[ $noimageifnotneeded == yes ]] && [[ $hostonly ]]; then
1531 if [[ ! -f "$initdir/lib/dracut/need-initqueue" ]] && \
1532 [[ -f ${initdir}/lib/modules/$kernel/modules.dep && ! -s ${initdir}/lib/modules/$kernel/modules.dep ]]; then
1533 for i in ${initdir}/etc/cmdline.d/*.conf; do
1534 # We need no initramfs image and do not generate one.
1535 [[ $i == "${initdir}/etc/cmdline.d/*.conf" ]] && exit 0
1536 done
1537 fi
1538 fi
89d44e72 1539fi
d8aeb3a7 1540
998bf6e0 1541if [[ $kernel_only != yes ]]; then
3c001899
HH
1542 (( ${#install_items[@]} > 0 )) && inst_multiple ${install_items[@]}
1543 (( ${#install_optional_items[@]} > 0 )) && inst_multiple -o ${install_optional_items[@]}
998bf6e0 1544
b093aa2d 1545 [[ $kernel_cmdline ]] && printf "%s\n" "$kernel_cmdline" >> "${initdir}/etc/cmdline.d/01-default.conf"
d20fb951 1546
694725ab 1547 for line in "${fstab_lines[@]}"; do
5f6a495b 1548 line=($line)
edbd9ca0
FV
1549
1550 if [ -z "${line[1]}" ]; then
1551 # Determine device and mount options from current system
1552 mountpoint -q "${line[0]}" || derror "${line[0]} is not a mount point!"
1553 line=($(findmnt --raw -n --target "${line[0]}" --output=source,target,fstype,options))
1554 dinfo "Line for ${line[1]}: ${line[@]}"
1555 else
1556 # Use default options
1557 [ -z "${line[3]}" ] && line[3]="defaults"
1558 fi
1559
1560 # Default options for freq and passno
5f6a495b
DY
1561 [ -z "${line[4]}" ] && line[4]="0"
1562 [ -z "${line[5]}" ] && line[5]="2"
edbd9ca0 1563
3586a7aa 1564 strstr "${line[2]}" "nfs" && line[5]="0"
5f6a495b 1565 echo "${line[@]}" >> "${initdir}/etc/fstab"
998bf6e0
HH
1566 done
1567
1568 for f in $add_fstab; do
b093aa2d 1569 cat "$f" >> "${initdir}/etc/fstab"
998bf6e0
HH
1570 done
1571
27d7936f 1572 if [[ $systemdutildir ]]; then
2da041d6
HH
1573 if [ -d ${initdir}/$systemdutildir ]; then
1574 mkdir -p ${initdir}/etc/conf.d
1575 {
1576 printf "%s\n" "systemdutildir=\"$systemdutildir\""
1577 printf "%s\n" "systemdsystemunitdir=\"$systemdsystemunitdir\""
1578 printf "%s\n" "systemdsystemconfdir=\"$systemdsystemconfdir\""
1579 } > ${initdir}/etc/conf.d/systemd.conf
1580 fi
6c6d8057
HH
1581 fi
1582
998bf6e0
HH
1583 if [[ $DRACUT_RESOLVE_LAZY ]] && [[ $DRACUT_INSTALL ]]; then
1584 dinfo "*** Resolving executable dependencies ***"
f182cb95 1585 find "$initdir" -type f -perm /0111 -not -path '*.ko' -print0 \
f7f5b82b 1586 | xargs -r -0 $DRACUT_INSTALL ${initdir:+-D "$initdir"} -R ${DRACUT_FIPS_MODE:+-f} --
db4d6bb4 1587 dinfo "*** Resolving executable dependencies done ***"
998bf6e0 1588 fi
8dcc4830 1589
ed9281d6
HH
1590 # Now we are done with lazy resolving, always install dependencies
1591 unset DRACUT_RESOLVE_LAZY
1592 export DRACUT_RESOLVE_DEPS=1
1593
8dcc4830
HH
1594 # libpthread workaround: pthread_cancel wants to dlopen libgcc_s.so
1595 for _dir in $libdirs; do
1596 for _f in "$_dir/libpthread.so"*; do
1597 [[ -e "$_f" ]] || continue
1598 inst_libdir_file "libgcc_s.so*"
1599 break 2
1600 done
1601 done
998bf6e0
HH
1602fi
1603
694725ab
HH
1604for ((i=0; i < ${#include_src[@]}; i++)); do
1605 src="${include_src[$i]}"
1606 target="${include_target[$i]}"
c9364f6e 1607 if [[ $src && $target ]]; then
661f9a34 1608 if [[ -f $src ]]; then
c9364f6e 1609 inst $src $target
661f9a34 1610 else
3b403b32 1611 ddebug "Including directory: $src"
c9364f6e 1612 destdir="${initdir}/${target}"
332ecaa9 1613 mkdir -p "$destdir"
dbad9f46 1614 # check for preexisting symlinks, so we can cope with the
fd786adc 1615 # symlinks to $prefix
c9364f6e
EV
1616 # Objectname is a file or a directory
1617 for objectname in "$src"/*; do
1618 [[ -e "$objectname" || -h "$objectname" ]] || continue
1619 if [[ -d "$objectname" ]]; then
1620 # objectname is a directory, let's compute the final directory name
1621 object_destdir=${destdir}/${objectname#$src/}
1622 if ! [[ -e "$object_destdir" ]]; then
1623 mkdir -m 0755 -p "$object_destdir"
1624 chmod --reference="$objectname" "$object_destdir"
dbad9f46 1625 fi
7e51a94f 1626 $DRACUT_CP -t "$object_destdir" "$objectname"/*
dbad9f46 1627 else
7e51a94f 1628 $DRACUT_CP -t "$destdir" "$objectname"
3b403b32 1629 fi
dbad9f46 1630 done
661f9a34 1631 fi
4fea3ea6 1632 fi
661f9a34 1633done
88ffd2df 1634
14c47b0e 1635if [[ $kernel_only != yes ]]; then
1254925f
HH
1636 # make sure that library links are correct and up to date
1637 for f in /etc/ld.so.conf /etc/ld.so.conf.d/*; do
482c573d 1638 [[ -f $f ]] && inst_simple "$f"
1254925f
HH
1639 done
1640 if ! ldconfig -r "$initdir"; then
647b521f 1641 if [[ $EUID = 0 ]]; then
1254925f
HH
1642 derror "ldconfig exited ungracefully"
1643 else
1644 derror "ldconfig might need uid=0 (root) for chroot()"
1645 fi
432196ae
1646 fi
1647fi
fdc421db 1648
404815ea
HH
1649if [[ $do_hardlink = yes ]] && command -v hardlink >/dev/null; then
1650 dinfo "*** Hardlinking files ***"
1651 hardlink "$initdir" 2>&1
1652 dinfo "*** Hardlinking files done ***"
1653fi
1654
3b403b32 1655# strip binaries
98adb06e 1656if [[ $do_strip = yes ]] ; then
8b6d136e
DM
1657 # Prefer strip from elfutils for package size
1658 declare strip_cmd=$(command -v eu-strip)
1659 test -z "$strip_cmd" && strip_cmd="strip"
1660
1661 for p in $strip_cmd xargs find; do
cc02093d 1662 if ! type -P $p >/dev/null; then
fefd3f66 1663 dinfo "Could not find '$p'. Not stripping the initramfs."
cc02093d
HH
1664 do_strip=no
1665 fi
31f7db66
HH
1666 done
1667fi
1668
f6e777ec
HH
1669# cleanup empty ldconfig_paths directories
1670for d in $(ldconfig_paths); do
1671 rmdir -p --ignore-fail-on-non-empty "$initdir/$d" >/dev/null 2>&1
1672done
1673
5f2c30d9
KRW
1674if [[ $early_microcode = yes ]]; then
1675 dinfo "*** Generating early-microcode cpio image ***"
1676 ucode_dir=(amd-ucode intel-ucode)
1677 ucode_dest=(AuthenticAMD.bin GenuineIntel.bin)
b5b608e4 1678 _dest_dir="$early_cpio_dir/d/kernel/x86/microcode"
5f2c30d9
KRW
1679 _dest_idx="0 1"
1680 mkdir -p $_dest_dir
1681 if [[ $hostonly ]]; then
1682 [[ $(get_cpu_vendor) == "AMD" ]] && _dest_idx="0"
1683 [[ $(get_cpu_vendor) == "Intel" ]] && _dest_idx="1"
1684 fi
1685 for idx in $_dest_idx; do
1686 _fw=${ucode_dir[$idx]}
1687 for _fwdir in $fw_dir; do
1688 if [[ -d $_fwdir && -d $_fwdir/$_fw ]]; then
1689 _src="*"
f18d069d 1690 dinfo "*** Constructing ${ucode_dest[$idx]} ***"
5f2c30d9
KRW
1691 if [[ $hostonly ]]; then
1692 _src=$(get_ucode_file)
b44156c6 1693 [[ $_src ]] || break
efba549a 1694 [[ -r $_fwdir/$_fw/$_src ]] || break
5f2c30d9 1695 fi
efba549a 1696
583fb231 1697 for i in $_fwdir/$_fw/$_src; do
efba549a 1698 [ -e "$i" ] && break
583fb231
HH
1699 break 2
1700 done
c44d2252
HH
1701 for i in $_fwdir/$_fw/$_src; do
1702 [[ -e "$i" ]] || continue
1703 # skip gpg files
1704 str_ends "$i" ".asc" && continue
1705 cat "$i" >> $_dest_dir/${ucode_dest[$idx]}
1706 done
d8b04dc1 1707 create_early_cpio="yes"
5f2c30d9
KRW
1708 fi
1709 done
1710 done
5f2c30d9 1711fi
bbaa0d59 1712
f3b14c2b
TR
1713if [[ $acpi_override = yes ]] && [[ -d $acpi_table_dir ]]; then
1714 dinfo "*** Packaging ACPI tables to override BIOS provided ones ***"
1715 _dest_dir="$early_cpio_dir/d/kernel/firmware/acpi"
1716 mkdir -p $_dest_dir
1717 for table in $acpi_table_dir/*.aml; do
1718 dinfo " Adding ACPI table: $table"
7e51a94f 1719 $DRACUT_CP $table $_dest_dir
f3b14c2b
TR
1720 create_early_cpio="yes"
1721 done
1722fi
1723
659dc319
HB
1724dinfo "*** Store current command line parameters ***"
1725if ! ( echo $PARMS_TO_STORE > $initdir/lib/dracut/build-parameter.txt ); then
1726 dfatal "Could not store the current command line parameters"
1727 exit 1
1728fi
1729
76dd870b 1730if [[ $hostonly_cmdline == "yes" ]] ; then
496e3d96 1731 unset _stored_cmdline
fe273e39
HR
1732 if [ -d $initdir/etc/cmdline.d ];then
1733 dinfo "Stored kernel commandline:"
1734 for conf in $initdir/etc/cmdline.d/*.conf ; do
496e3d96 1735 [ -e "$conf" ] || continue
fe273e39 1736 dinfo "$(< $conf)"
496e3d96 1737 _stored_cmdline=1
fe273e39 1738 done
496e3d96
HH
1739 fi
1740 if ! [[ $_stored_cmdline ]]; then
62c00a88 1741 dinfo "No dracut internal kernel commandline stored in the initramfs"
fe273e39
HR
1742 fi
1743fi
62c00a88 1744
095e1f37 1745if dracut_module_included "squash"; then
6a74c03b 1746 dinfo "*** Install squash loader ***"
095e1f37
KS
1747 if ! check_kernel_config CONFIG_SQUASHFS; then
1748 dfatal "CONFIG_SQUASHFS have to be enabled for dracut squash module to work"
1749 exit 1
1750 fi
1751 if ! check_kernel_config CONFIG_OVERLAY_FS; then
1752 dfatal "CONFIG_OVERLAY_FS have to be enabled for dracut squash module to work"
1753 exit 1
1754 fi
1755 if ! check_kernel_config CONFIG_DEVTMPFS; then
1756 dfatal "CONFIG_DEVTMPFS have to be enabled for dracut squash module to work"
1757 exit 1
1758 fi
1759
6a74c03b 1760 readonly squash_dir="$initdir/squash/root"
095e1f37
KS
1761 readonly squash_img=$initdir/squash/root.img
1762
1763 # Currently only move "usr" "etc" to squashdir
1764 readonly squash_candidate=( "usr" "etc" )
1765
1766 mkdir -m 0755 -p $squash_dir
1767 for folder in "${squash_candidate[@]}"; do
1768 mv $initdir/$folder $squash_dir/$folder
1769 done
1770
095e1f37
KS
1771 # Move some files out side of the squash image, including:
1772 # - Files required to boot and mount the squashfs image
f18d069d 1773 # - Files need to be accessible without mounting the squash image
095e1f37
KS
1774 required_in_root() {
1775 local file=$1
1776 local _sqsh_file=$squash_dir/$file
1777 local _init_file=$initdir/$file
1778
1779 if [[ -e $_init_file ]]; then
1780 return
1781 fi
1782
1783 if [[ ! -e $_sqsh_file ]] && [[ ! -L $_sqsh_file ]]; then
1784 derror "$file is required to boot a squashed initramfs but it's not installed!"
1785 return
1786 fi
1787
1788 if [[ ! -d $(dirname $_init_file) ]]; then
1789 required_in_root $(dirname $file)
1790 fi
1791
f6bbd024
KS
1792 if [[ -L $_sqsh_file ]]; then
1793 cp --preserve=all -P $_sqsh_file $_init_file
1794 _sqsh_file=$(realpath $_sqsh_file 2>/dev/null)
1795 if [[ -e $_sqsh_file ]] && [[ "$_sqsh_file" == "$squash_dir"* ]]; then
1796 # Relative symlink
1797 required_in_root ${_sqsh_file#$squash_dir/}
1798 return
1799 fi
1800 if [[ -e $squash_dir$_sqsh_file ]]; then
1801 # Absolute symlink
1802 required_in_root ${_sqsh_file#/}
1803 return
1804 fi
1805 required_in_root ${module_spec#$squash_dir/}
095e1f37 1806 else
f6bbd024
KS
1807 if [[ -d $_sqsh_file ]]; then
1808 mkdir $_init_file
1809 else
1810 mv $_sqsh_file $_init_file
1811 fi
095e1f37
KS
1812 fi
1813 }
1814
1815 required_in_root etc/initrd-release
1816
1817 for module_spec in $squash_dir/usr/lib/modules/*/modules.*;
1818 do
1819 required_in_root ${module_spec#$squash_dir/}
1820 done
1821
1822 for dracut_spec in $squash_dir/usr/lib/dracut/*;
1823 do
1824 required_in_root ${dracut_spec#$squash_dir/}
1825 done
1826
1827 mv $initdir/init $initdir/init.stock
095e1f37 1828 ln -s squash/init.sh $initdir/init
095e1f37 1829
19e57585
KS
1830 # Reinstall required files for the squash image setup script.
1831 # We have moved them inside the squashed image, but they need to be
1832 # accessible before mounting the image.
1833 inst_multiple "echo" "sh" "mount" "modprobe" "mkdir"
1834 hostonly="" instmods "loop" "squashfs" "overlay"
1835
1836 # Only keep systemctl outsite if we need switch root
1837 if [[ ! -f "$initdir/lib/dracut/no-switch-root" ]]; then
1838 inst "systemctl"
1839 fi
1840
1841 for folder in "${squash_candidate[@]}"; do
1842 # Remove duplicated files in squashfs image, save some more space
1843 [[ ! -d $initdir/$folder/ ]] && continue
1844 for file in $(find $initdir/$folder/ -not -type d);
1845 do
1846 if [[ -e $squash_dir${file#$initdir} ]]; then
1847 mv $squash_dir${file#$initdir} $file
1848 fi
1849 done
1850 done
6a74c03b 1851fi
19e57585 1852
6a74c03b
KS
1853if [[ $do_strip = yes ]] && ! [[ $DRACUT_FIPS_MODE ]]; then
1854 dinfo "*** Stripping files ***"
1855 find "$initdir" -type f \
1856 -executable -not -path '*/lib/modules/*.ko' -print0 \
1857 | xargs -r -0 $strip_cmd -g -p 2>/dev/null
1858
1859 # strip kernel modules, but do not touch signed modules
1860 find "$initdir" -type f -path '*/lib/modules/*.ko' -print0 \
1861 | while read -r -d $'\0' f || [ -n "$f" ]; do
1862 SIG=$(tail -c 28 "$f" | tr -d '\000')
1863 [[ $SIG == '~Module signature appended~' ]] || { printf "%s\000" "$f"; }
1864 done | xargs -r -0 $strip_cmd -g -p
1865 dinfo "*** Stripping files done ***"
1866fi
1867
1868if dracut_module_included "squash"; then
1869 dinfo "*** Squashing the files inside the initramfs ***"
095e1f37
KS
1870 mksquashfs $squash_dir $squash_img -comp xz -b 64K -Xdict-size 100% &> /dev/null
1871
1872 if [[ $? != 0 ]]; then
1873 dfatal "dracut: Failed making squash image"
1874 exit 1
1875 fi
6a74c03b
KS
1876
1877 rm -rf $squash_dir
1878 dinfo "*** Squashing the files inside the initramfs done ***"
095e1f37
KS
1879fi
1880
6a74c03b
KS
1881dinfo "*** Creating image file '$outfile' ***"
1882
636d2d46 1883if [[ $uefi = yes ]]; then
62c00a88
HH
1884 readonly uefi_outdir="$DRACUT_TMPDIR/uefi"
1885 mkdir "$uefi_outdir"
636d2d46 1886fi
c8a9a6b4 1887
80626ded
HH
1888if [[ $DRACUT_REPRODUCIBLE ]]; then
1889 find "$initdir" -newer "$dracutbasedir/dracut-functions.sh" -print0 \
1890 | xargs -r -0 touch -h -m -c -r "$dracutbasedir/dracut-functions.sh"
1891
10f8df1b
HH
1892 if [[ "$(cpio --help)" == *--reproducible* ]]; then
1893 CPIO_REPRODUCIBLE=1
1894 else
1895 dinfo "cpio does not support '--reproducible'. Resulting image will not be reproducible."
1896 fi
80626ded
HH
1897fi
1898
647b521f 1899[[ "$EUID" != 0 ]] && cpio_owner_root="-R 0:0"
c8a9a6b4 1900
b5b608e4 1901if [[ $create_early_cpio = yes ]]; then
b9909e33 1902 echo 1 > "$early_cpio_dir/d/early_cpio"
80626ded
HH
1903
1904 if [[ $DRACUT_REPRODUCIBLE ]]; then
1905 find "$early_cpio_dir/d" -newer "$dracutbasedir/dracut-functions.sh" -print0 \
1906 | xargs -r -0 touch -h -m -c -r "$dracutbasedir/dracut-functions.sh"
1907 fi
1908
5f2c30d9 1909 # The microcode blob is _before_ the initramfs blob, not after
62c00a88 1910 if ! (
0db98910 1911 umask 077; cd "$early_cpio_dir/d"
62c00a88
HH
1912 find . -print0 | sort -z \
1913 | cpio ${CPIO_REPRODUCIBLE:+--reproducible} --null $cpio_owner_root -H newc -o --quiet > "${DRACUT_TMPDIR}/initramfs.img"
1914 ); then
1915 dfatal "dracut: creation of $outfile failed"
1916 exit 1
1917 fi
5f2c30d9 1918fi
80626ded
HH
1919
1920if ! (
1921 umask 077; cd "$initdir"
1922 find . -print0 | sort -z \
1923 | cpio ${CPIO_REPRODUCIBLE:+--reproducible} --null $cpio_owner_root -H newc -o --quiet \
62c00a88 1924 | $compress >> "${DRACUT_TMPDIR}/initramfs.img"
80626ded 1925 ); then
dc4c1ee3 1926 dfatal "dracut: creation of $outfile failed"
734a0d9e 1927 exit 1
3b403b32 1928fi
2cc5e92e 1929
bd93e928 1930if (( maxloglvl >= 5 )) && (( verbosity_mod_l >= 0 )); then
dadd2b69 1931 if [[ $allowlocal ]]; then
62c00a88 1932 "$dracutbasedir/lsinitrd.sh" "${DRACUT_TMPDIR}/initramfs.img"| ddebug
dadd2b69 1933 else
62c00a88 1934 lsinitrd "${DRACUT_TMPDIR}/initramfs.img"| ddebug
dadd2b69 1935 fi
bbaa0d59 1936fi
1faecdc1 1937
60928f36
HH
1938umask 077
1939
636d2d46
HH
1940if [[ $uefi = yes ]]; then
1941 if [[ $kernel_cmdline ]]; then
1942 echo -n "$kernel_cmdline" > "$uefi_outdir/cmdline.txt"
1943 elif [[ $hostonly_cmdline = yes ]] && [ -d $initdir/etc/cmdline.d ];then
1944 for conf in $initdir/etc/cmdline.d/*.conf ; do
1945 [ -e "$conf" ] || continue
1946 printf "%s " "$(< $conf)" >> "$uefi_outdir/cmdline.txt"
1947 done
1948 else
1949 do_print_cmdline > "$uefi_outdir/cmdline.txt"
1950 fi
1951 echo -ne "\x00" >> "$uefi_outdir/cmdline.txt"
1952
1953 dinfo "Using UEFI kernel cmdline:"
1954 dinfo $(< "$uefi_outdir/cmdline.txt")
1955
3ac9cdb1 1956 [[ -s /usr/lib/os-release ]] && uefi_osrelease="/usr/lib/os-release"
636d2d46
HH
1957 [[ -s /etc/os-release ]] && uefi_osrelease="/etc/os-release"
1958
62c00a88
HH
1959 if objcopy \
1960 ${uefi_osrelease:+--add-section .osrel=$uefi_osrelease --change-section-vma .osrel=0x20000} \
1961 --add-section .cmdline="${uefi_outdir}/cmdline.txt" --change-section-vma .cmdline=0x30000 \
1962 --add-section .linux="$kernel_image" --change-section-vma .linux=0x40000 \
1963 --add-section .initrd="${DRACUT_TMPDIR}/initramfs.img" --change-section-vma .initrd=0x3000000 \
5a962b59
MR
1964 "$uefi_stub" "${uefi_outdir}/linux.efi"; then
1965 if [[ -n "${uefi_secureboot_key}" && -n "${uefi_secureboot_cert}" ]]; then \
1966 if sbsign \
1967 --key "${uefi_secureboot_key}" \
1968 --cert "${uefi_secureboot_cert}" \
1969 --output "$outfile" "${uefi_outdir}/linux.efi"; then
1970 dinfo "*** Creating signed UEFI image file '$outfile' done ***"
1971 else
1972 dfatal "*** Creating signed UEFI image file '$outfile' failed ***"
1973 exit 1
1974 fi
1975 else
1976 if cp --reflink=auto "${uefi_outdir}/linux.efi" "$outfile"; then
1977 dinfo "*** Creating UEFI image file '$outfile' done ***"
1978 fi
1979 fi
62c00a88
HH
1980 else
1981 rm -f -- "$outfile"
1982 dfatal "*** Creating UEFI image file '$outfile' failed ***"
1983 exit 1
1984 fi
1985else
60928f36 1986 if cp --reflink=auto "${DRACUT_TMPDIR}/initramfs.img" "$outfile"; then
62c00a88
HH
1987 dinfo "*** Creating initramfs image file '$outfile' done ***"
1988 else
1989 rm -f -- "$outfile"
1990 dfatal "dracut: creation of $outfile failed"
1991 exit 1
1992 fi
636d2d46
HH
1993fi
1994
60928f36 1995command -v restorecon &>/dev/null && restorecon -- "$outfile"
62c00a88 1996
740e41b8
CW
1997# We sync/fsfreeze only if we're operating on a live booted system.
1998# It's possible for e.g. `kernel` to be installed as an RPM BuildRequires or equivalent,
1999# and there's no reason to sync, and *definitely* no reason to fsfreeze.
2000# Another case where this happens is rpm-ostree, which performs its own sync/fsfreeze
2001# globally. See e.g. https://github.com/ostreedev/ostree/commit/8642ef5ab3fec3ac8eb8f193054852f83a8bc4d0
2002if test -d /run/systemd/system; then
2003 if ! sync "$outfile" 2> /dev/null; then
2004 dinfo "dracut: sync operation on newly created initramfs $outfile failed"
2005 exit 1
2006 fi
7bc681fd 2007
740e41b8
CW
2008 # use fsfreeze only if we're not writing to /
2009 if [[ "$(stat -c %m -- "$outfile")" != "/" && "$(stat -f -c %T -- "$outfile")" != "msdos" ]]; then
2010 if ! $(fsfreeze -f $(dirname "$outfile") 2>/dev/null && fsfreeze -u $(dirname "$outfile") 2>/dev/null); then
2011 dinfo "dracut: warning: could not fsfreeze $(dirname "$outfile")"
2012 fi
de576db3 2013 fi
e316ae0e
AK
2014fi
2015
3da58569 2016exit 0